<!doctype html>
<html lang="en">
  <head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css" integrity="sha384-9aIt2nRpC12Uk9gS9baDl411NQApFmC26EwAOH8WgZl5MYYxFfc+NcPb1dKGj7Sk" crossorigin="anonymous">

    <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js" integrity="sha384-OgVRvuATP1z7JjHLkuOU7Xw704+h835Lr+6QL9UvYjZE3Ipu6Tp75j7Bh/kR0JKI" crossorigin="anonymous"></script>

    <script src="https://apis.google.com/js/platform.js" async defer></script>
    <meta name="google-signin-client_id" content="970611167737-vmpvppuijkoothkqnn6u3b5cfptm3amc.apps.googleusercontent.com">

    <title>CRUD</title>
  </head>
  <body class="jumbotron vertical-center">
    
    <script>
      var token = '';
      var userID = '';
      var userIMG = '';
        function seleccion(){
          var seleccion = document.getElementById('selector');
          switch(seleccion.options[seleccion.selectedIndex].value){
              case "1":{
                  document.getElementById("formCrear").style.display="block";
                  document.getElementById("userListContainer").style.display="none";
                  break;
              }
              case "2":{
                  mostrarUsers();

                  //console.log(JSON.parse(xmlHttp.responseText));
                  
                  break;
              }
          }
        }

        function mostrarUsers(){
          document.getElementById("formCrear").style.display="none";
          document.getElementById("userList").innerHTML='';
          document.getElementById("userListContainer").style.display="block";
          var xhr = new XMLHttpRequest(); 
          xhr.open( "GET", "/usuario", false ); // false for synchronous request
          xhr.setRequestHeader('token', token);
          xhr.onload = function(){
            var data = JSON.parse(xhr.responseText).usuarios;
            for(var item in data){
              document.getElementById('userList').innerHTML += (
                '<li id='+data[item]._id +' class="list-group-item d-flex justify-content-between list-group-item-action" style="line-height: 32px">' + '<span> <span style="font-weight: bold;">' + data[item].nombre + '</span>' + "\t(" + data[item].email + ")" + '</span>' + 
                  '<span>' +
                    '<button type="button" class="btn mr-1 btn-warning" onclick="showEditarUser({id:\''+data[item]._id+'\',nombre:\''+data[item].nombre+'\',email:\''+data[item].email+'\'})">EDITAR</button>' +
                    '<button type="button" class="btn btn-danger" onclick="eliminarUser(\''+data[item]._id+'\')">ELIMINAR</button>' +
                  '</span>' +
                '</li>' +
                '<div id="editar_'+data[item]._id+'" class="editarUser vertical-center list-group pt-2 pl-4 pb-4 bg-light" style="display:none"></div>'
                );
              console.log(data[item]._id);
            }
          }
          console.log("ENVIANDO TOKEN: " + token);
          xhr.send( null );
        }

        function showEditarUser(user){
          if(document.getElementById("editar_"+user.id).classList.contains("editarActivo")){ //si esta activo
            document.getElementById("editar_"+user.id).classList.remove("editarActivo"); //quita activo
            document.getElementById("editar_"+user.id).style.display='none';             //oculta
            document.getElementById("editar_"+user.id).innerHTML='';                    //elimina interior
          }else{
            Array.from(document.getElementsByClassName("editarUser")).forEach(function(element, index, array) {
              element.classList.remove("editarActivo");
              element.innerHTML='';
              element.style.display='none';
            });

            document.getElementById("editar_"+user.id).classList.add("editarActivo");
            document.getElementById("editar_"+user.id).innerHTML = editarForm(user);
            document.getElementById("editar_"+user.id).style.display='block';
          }
        }


        function editarForm(user){
          return  '<form id="formEditar" onsubmit="return false">' +
                    '<div class="form-row">' +
                      '<div class="col-md-6 mb-3">' +
                        '<label for="validacionombre">Nombre</label>' +
                        '<input id="formEditarNombre" type="text" class="form-control" name="nombre" required value="'+user.nombre+'">' +
                      '</div>' +
                    '</div>' +

                    '<div class="form-row">' +
                      '<div class="col-md-6 mb-3">' +
                        '<label for="validacionemail">Email</label>' +
                        '<input id="formEditarEmail" type="email" class="form-control" name="email" required value="'+user.email+'">' +
                      '</div>' +
                    '</div>' +

                    '<div class="form-row">' + 
                      '<div class="col-md-6 mb-3">' +
                        '<label for="validacioncontrasena">Contraseña</label>' +
                        '<input id="formEditarPassword" type="password" class="form-control" name="password" required>' +
                      '</div>' +
                    '</div>' +
                  
                    '<button class="btn btn-primary" type="submit" onclick="actualizarUser(\''+user.id+'\')">ACTUALIZAR</button>' +
                  '</form>'
        }

        function actualizarUser(userID){
          var data = {};
          data.nombre = document.getElementById("formEditarNombre").value;
          data.email  = document.getElementById("formEditarEmail").value;
          data.password = document.getElementById("formEditarPassword").value;

          var json = JSON.stringify(data);

          var xhr = new XMLHttpRequest();
          xhr.open("PUT", "/usuario/" + userID, true);
          xhr.setRequestHeader('Content-type','application/json; charset=utf-8');
          xhr.onload = function () {
            var response = JSON.parse(xhr.responseText);
            if (xhr.readyState == 4 && xhr.status == "200") { //OK
              document.getElementById('editar_'+userID).style.display='none';
              document.getElementById('editar_'+userID).classList.remove("editarActivo");
              document.getElementById('editar_'+userID).innerHTML='';
              console.table(response);

              mostrarUsers();

            } else {                                        //ERROR
              console.error(response);
            }
          }
          xhr.send(json);

          
        }

        function eliminarUser(userID){
          console.log("Eliminando user con id: " + userID);
          var xhr = new XMLHttpRequest();
          xhr.open("DELETE", "/usuario/" + userID, true);
          xhr.onload = function () {
            var response = JSON.parse(xhr.responseText);
            if (xhr.readyState == 4 && xhr.status == "200") { //cuando se borro user correctamente
              document.getElementById(userID).parentNode.removeChild(document.getElementById(userID));
            } else {                                         //cuando hubo error al borrar
              console.error(response);
            }
          }
          xhr.send(null);
        }

        function logearUsuario(email,password){
          console.log("FORM EMAIL: " + email);
          console.log("FORM PASSWORD: " + password);
          var xhr = new XMLHttpRequest();
          xhr.open("POST", "/login", true);
          xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");

          xhr.onload = function () {
            console.log("LOCAL SIGN-IN INFO: " + xhr.responseText);
            var response = JSON.parse(xhr.responseText);
            if (xhr.readyState == 4 && xhr.status == "200") { //respuesta del server correcta
              token = response.token;
              document.getElementById("loginContainer").style.display = "none";
              document.getElementById("crudContainer").style.display = "block";
              document.getElementById("loggedUsername").innerHTML = response.Usuario.nombre;
              document.getElementById("loggedEmail").innerHTML = response.Usuario.email;
              document.getElementById("loggedPicture").src = response.Usuario.profilePicture;
            } else {                                         //sin respuesta del server
              document.getElementById("loginContainer").style.display = "block";
              document.getElementById("crudContainer").style.display = "none";
              console.error(response);
            }
          }
          xhr.send("email=" + email + "&password=" + password);
        }

        function onSignIn(googleUser) {
                var profile = googleUser.getBasicProfile();
                console.log("ID: " + profile.getId());
                console.log("Name: " + profile.getName());
                console.log("Image URL: " + profile.getImageUrl());
                console.log("Email: " + profile.getEmail());

                var id_token = googleUser.getAuthResponse().id_token;

                var xhr = new XMLHttpRequest();
                xhr.open("POST", "/google");
                xhr.setRequestHeader(
                    "Content-Type", 
                    "application/x-www-form-urlencoded"
                    );
                xhr.onload = function() {
                  console.log("GOOGLE SIGN-IN INFO: " + xhr.responseText);
                  var response = JSON.parse(xhr.responseText);
                  if (xhr.readyState == 4 && xhr.status == "200") { //respuesta del server correcta
                    token = response.token;
                    userID = response.usuario._id;
                    userIMG = response.usuario.img;
                    document.getElementById("loggedUsername").innerHTML=(response.usuario.nombre);
                    document.getElementById("loggedEmail").innerHTML="(" + (response.usuario.email) + ")";

                    document.getElementById("loggedPicture").src = response.usuario.profilePicture;
                    document.getElementById("loginContainer").style.display = "none";
                    document.getElementById("crudContainer").style.display = "block";
                  } else {                                         //sin respuesta del server
                    document.getElementById("loginContainer").style.display = "block";
                    document.getElementById("crudContainer").style.display = "none";
                    console.error(response);
                  }
                };
                xhr.send("idtoken=" + id_token);
            }


            function signOut() {
              var auth2 = gapi.auth2.getAuthInstance();
              auth2.signOut().then(function () {
                console.log('User signed out.');
                document.getElementById("loginContainer").style.display = "block";
                document.getElementById("crudContainer").style.display = "none";

                document.getElementById('uploadStatus').style.display = "none";
                document.getElementById("userImage").src='';

              });
            }

            function uploadFile(localFile){
              console.log(localFile);
              var xhr = new XMLHttpRequest();
              var formData = new FormData();
              formData.append("archivo", localFile);
              xhr.open("PUT", "/upload/usuarios/" + userID, true);
              //xhr.setRequestHeader('Content-type','application/json; charset=utf-8');
              xhr.onload = function () {
                var response = JSON.parse(xhr.responseText);
                if (xhr.readyState == 4 && xhr.status == "200") { //OK
                  
                  if(response.ok){
                    document.getElementById('uploadStatus').style.display = "block";
                    document.getElementById('uploadStatus').innerHTML = "Imagen subida correctamente!";
                    document.getElementById('uploadStatus').style.color = "blue";
                    
                    var xhr2 = new XMLHttpRequest();
                    xhr2.open("GET", "/imagen/usuarios/" + response.img, true);
                    xhr2.onload = function () {
                      if (xhr2.readyState == 4 && xhr2.status == "200") { //OK
                        userIMG = xhr2.responseURL;
                        document.getElementById("userImage").src=xhr2.responseURL;
                      } else {                                        //ERROR
                        console.error(response2);
                      }
                    }
                    xhr2.send(null);
                  }

                } else {                                        //ERROR
                  console.error(response);
                  document.getElementById('uploadStatus').style.display = "block";
                  document.getElementById('uploadStatus').style.color = "red";
                  document.getElementById('uploadStatus').innerHTML = response.err.message + " intente nuevamente";
                }
              }
              xhr.send(formData);
            }

            function getImage(){
              var xhr = new XMLHttpRequest();
              xhr.open("GET", "/imagen/usuarios/" + userIMG.split('/')[userIMG.split('/').length-1], true);
              
              xhr.onload = function () {
                if (xhr.readyState == 4 && xhr.status == "200") { //OK
                  document.getElementById('uploadStatus').style.display = "block";
                  document.getElementById('uploadStatus').innerHTML = "Imagen cargada correctamente!";
                  document.getElementById('uploadStatus').style.color = "green";
                  document.getElementById('userImage').src=xhr.responseURL;
                } else {                                        //ERROR
                  console.error(response);
                  document.getElementById('uploadStatus').style.display = "block";
                  document.getElementById('uploadStatus').style.color = "red";
                  document.getElementById('uploadStatus').innerHTML = response.err.message;
                }
              }
              xhr.send(null);
            }

    </script>

    <div id="loginContainer" class="container" style="display:block"> <!-- LOGIN -->
      <div class="row justify-content-center align-items-center" style="height:100vh">
        <div class="col-4">
          <div class="card">
            <div class="card-body">
              <p class="text-center font-weight-bold h2 mb-4">Leoric website</p>
              <div class="container d-flex justify-content-center">
                <div class="g-signin2 col-" data-onsuccess="onSignIn"></div>
              </div>

              <div class="container d-flex justify-content-center">
                <p class="mt-4"> ó </p>
              </div>

              <form action="" autocomplete="off" onsubmit="return false">
                <div class="form-group">
                  <p>Email:</p>
                  <input id="loginEmail" type="text" class="form-control" name="email">
                </div>
                <div class="form-group">
                  <p>Password:</p>
                  <input id="loginPassword" type="password" class="form-control" name="password" onkeydown="if (event.keyCode == 13)document.getElementById('sendLogin').click()">
                </div>
                <div class="container d-flex justify-content-center">
                  <div class="justify-content-center">
                    <button type="button" id="sendLogin" class="btn btn-primary" onclick="logearUsuario(document.getElementById('loginEmail').value,document.getElementById('loginPassword').value)">LOGIN</button>
                    
                  </div>
                </div>
              </form>
            
            </div>
          </div>
        </div>
      </div>
    </div>

    <div id="crudContainer" style="display: none;">                                            <!--///////////MENU OPCIONES CRUD-->
      <div class="fixed-top d-flex justify-content-end align-items-center mr-4" style="height:80px;">
        <p class="align-self-center m-1" id="loggedUsername"></p>
        <p class="font-weight-bold align-self-center m-1" id="loggedEmail"></p>
        <img id="loggedPicture" class="img-fluid h-50 m-2" src="" alt="">
        <button class="btn btn-primary h-50 p-2 bd-highlight" onclick="signOut();">CERRAR SESION</button>
      </div>
      
      <h1 class="display-4">Realiza tu operacion CRUD</h1>
      <div class="mb-3">
        <select id="selector" class="custom-select" required onchange="seleccion()">
          <option value="" disabled selected>Escoger operacion</option>
          <option value="" disabled>--------------------------------</option>
          <option value="1">Crear usuario [CRUD: CREAR]</option>
          <option value="2">Lista de usuarios [CRUD: LEER]</option>
        </select>
        <div class="invalid-feedback">Example invalid custom select feedback</div>
      </div>
  
      <form id="formCrear" style="display:none" action="/validarCrear" method="POST"> <!--//////////////////CREAR-->
          <div class="form-row">
            <div class="col-md-6 mb-3">
              <label for="validacionombre">Nombre</label>
              <input type="text" class="form-control" name="nombre"  required>
            </div>
          </div>
  
          <div class="form-row">
            <div class="col-md-6 mb-3">
              <label for="validacionemail">Email</label>
              <input type="email" class="form-control" name="email" required>
            </div>
          </div>
  
          <div class="form-row">
            <div class="col-md-6 mb-3">
              <label for="validacioncontrasena">Contraseña</label>
              <input type="password" class="form-control" name="password" required>
            </div>
          </div>
         
          <button class="btn btn-primary" type="submit">Enviar</button>
      </form>                                                                  <!--/////////////////////////CREAR-->
  
  
      <div id="userListContainer" style="display:none">                                      <!--==============================================================LISTA-->
        <p class="h3">Lista de usuarios</p>
        <ul id="userList" class="list-group list-inline"></ul>
      </div>                                     <!--==============================================================LISTA-->
  
    </div>

    <div id="uploadContainer">
      <h1 id="uploadHeader" class="display-4">Subir imagen</h1>
      <div class="container">
        <img id="userImage" src="" class="mb-3 img-responsive" width="300"></img>
      </div>
      <form onsubmit="return false">
        <div class="form-group">
          <label id="uploadStatus" for="fileUpload" style="display:none;"></label>
          <input id="fileUpload" type="file" class="form-control-file" >
        </div>
        <button class="btn btn-primary" type="button" onclick="uploadFile(document.getElementById('fileUpload').files[0])">CARGAR</button>
        <button class="btn btn-info" type="button" onclick="getImage()">VER IMAGEN</button>
      </form>
    </div>

  </body>
</html>